.TH DWM 1 dwm\-VERSION
.SH NAME
dwm \- dynamic window manager
.SH SYNOPSIS
.B dwm
.RB [ \-v ]
.SH DESCRIPTION
dwm is a dynamic window manager for X. By default it manages windows in tiled,
monocle(fullscreen) and floating layouts. Any layout can be applied dynamically,
optimising the environment for the application in use and the task performed.
.P
In tiled layouts windows are managed in a master and stacking area. The master
area on the left contains one window by default, and the stacking area on the
right contains all other windows. The number of master area windows can be
adjusted from zero to an arbitrary number. In monocle(fullscreen) layout all
windows are maximised to the screen size. In floating layout windows can be
resized and moved freely. Dialog windows are always managed floating, regardless
of the layout applied.
.P
Windows are grouped by tags. Each window can be tagged with one or multiple
tags. Selecting certain tags displays all windows with these tags.
.P
Each screen contains a small status bar which displays all available tags, the
layout, the title of the focused window, and the text read from the root window
name property which is used to display information with other programs.
A floating window is indicated with an empty square and a maximised floating
window is indicated with a filled square before the windows title. The selected
tags are indicated with a highlighting color. The tags of the focused window are
indicated with a filled square in the top left corner. The tags which have
one or more windows are indicated with an empty square in the top left corner.
.P
dwm draws a small border around windows to indicate the focus state.
.SH OPTIONS
.TP
.B \-v
prints version information to stderr, then exits.
.SH CUSTOMIZATION
dwm is customized by creating a custom config.h and (re)compiling the source
code. This keeps it fast, secure and simple.
.SH USAGE
.SS Status bar
.TP
.B X root window name
is read and displayed in the status text area. It can be set with the
.BR xsetroot (1)
command.
.TP
.B Button1
click on a tag label to display all windows with that tag, click on the layout
label toggles between tiled and floating layout.
.TP
.B Button3
click on a tag label adds/removes all windows with that tag to/from the view.
.TP
.B MODIFIERKEY + Button1
click on a tag label applies that tag to the focused window.
.TP
.B MODIFIERKEY + Button3
click on a tag label adds/removes that tag to/from the focused window.
.SS Keyboard commands
.TP
.B MODIFIERKEY + c
Start preferred terminal of choice. Defined in config.h.
.TP
.B MODIFIERKEY + Ctrl + c
Start secondary terminal of choice. Defined in config.h.
.TP
.B MODIFIERKEY + Shift + Return
Start preferred terminal of choice. Defined in config.h.
.TP
.B MODIFIERKEY + Ctrl + Shift + Return
Start secondary terminal of choice. Defined in config.h.
.TP
.B MODIFIERKEY + Shift + c
Close focused window.
.TP
.B MODIFIERKEY + f
Spawn
.BR rofi (1)
run launcher for launching other programs.
.TP
.B MODIFIERKEY + p
Spawn
.BR dmenu (1)
run launcher for launching other programs.
.TP
.B MODIFIERKEY + [1..9]
View all windows with that tag.
.TP
.B MODIFIERKEY + Shift + [1..9]
Apply that tag to the focused window.
.TP
.B MODIFIERKEY + Control + [1..9]
Toggle displaying all windows with that tag.
.TP
.B MODIFIERKEY + Control + Shift + [1..9]
Toggle that tag on focused window.
.TP
.B MODIFIERKEY + 0
View all windows with any tag.
.TP
.B MODIFIERKEY + Shift + 0
Apply all tags to focused window.
.TP
.B MODIFIERKEY + space
Toggles monocle(fullscreen) layout.
.TP
.B MODIFIERKEY + Shift + space
Toggles between all layouts (excluding floating/lack of a tiling layout).
.TP
.B MODIFIERKEY + i
Toggles monitor's status bar on and off.
.TP
.B MODIFIERKEY + Shift + i
Cycles monitor's status bar's which tagset is displayed on which monitor between off, on other monitors and always.
.TP
.B MODIFIERKEY + t
Toggle floating layout on selected window.
.TP
.B MODIFIERKEY + Tab
Fetch a window which is not shown.

Initiates a two stage layout change. First press switches to grid layout,
hides all tags displayed on this monitor and fetches all windows which were
not visible. User now sees all windows which were not visible and is now
expected to make the desired window to fetch the focused one and press
the keybind second time. Second press switches back to the old layout,
returns all windows back to their original places except for the selected
window which is kept here.
.TP
.B MODIFIERKEY + j
Focus previous(left/counter-clockwise) window.
.TP
.B MODIFIERKEY + k
Focus next(right/clockwise) window.
.TP
.B MODIFIERKEY + Shift + j
Swap selected window's slot with the previous one.
.TP
.B MODIFIERKEY + Shift + k
Swap selected window's slot with the next one.
.TP
.B MODIFIERKEY + h
Decrease master area size. Moves the divider to the left.
.TP
.B MODIFIERKEY + l
Increase master area size. Moves the divider to the right.
.TP
.B MODIFIERKEY + o
Reset master area size. Moves the divider to the default position.
.TP
.B MODIFIERKEY + Shift + h
Decrease height of selected window.
.TP
.B MODIFIERKEY + Shift + l
Increase height of selected window.
.TP
.B MODIFIERKEY + Shift + o
Resets height of selected window to default.
.TP
.B MODIFIERKEY + ,
Increase number of windows in master area.
.TP
.B MODIFIERKEY + .
Decrease number of windows in master area.
.TP
.B Left Alt + Tab
Cycle focus to the next monitor.
.TP
.B Left Alt + Shift + Tab
Cycle focus to the previous monitor.
.TP
.B MODIFIERKEY + r
Focuses monitor 1.
.TP
.B MODIFIERKEY + Shift + r
Move selected window to the tagset displayed on monitor 1.
.TP
.B MODIFIERKEY + e
Focuses monitor 2.
.TP
.B MODIFIERKEY + Shift + e
Move selected window to the tagset displayed on monitor 2.
.TP
.B MODIFIERKEY + w
Focuses monitor 3.
.TP
.B MODIFIERKEY + Shift + w
Move selected window to the tagset displayed on monitor 3.
.TP
.B MODIFIERKEY + q
Focuses monitor 4.
.TP
.B MODIFIERKEY + Shift + q
Move selected window to the tagset displayed on monitor 4.
.TP
.B MODIFIERKEY + Ctrl + Shift + l
run
.BR slock (1)
to lock the screen
.TP
.B MODIFIERKEY + Ctrl + Shift + s
.B systemctl suspend
.TP
.B MODIFIERKEY + Ctrl + Shift + h
.B systemctl hibernate
.TP
.B MODIFIERKEY + Ctrl + Shift + k
Quit dwm.
.TP
.B MODIFIERKEY + Ctrl + Shift + r
.B systemctl reboot
.TP
.B MODIFIERKEY + Ctrl + Shift + p
.B systemctl poweroff
.SS Mouse commands
.TP
.B MODIFIERKEY + Button1
Move focused window while dragging. Tiled windows will be toggled to the floating state.
.TP
.B MODIFIERKEY + Button2
Toggles focused window between floating and tiled state.
.TP
.B MODIFIERKEY + Button3
Resize focused window while dragging. Tiled windows will be toggled to the floating state.
.SH SEE ALSO
.BR rofi (1),
.BR dmenu (1),
.BR slock (1)
.SH ISSUES
Java applications which use the XToolkit/XAWT backend may draw grey windows
only. The XToolkit/XAWT backend breaks ICCCM-compliance in recent JDK 1.5 and early
JDK 1.6 versions, because it assumes a reparenting window manager. Possible workarounds
are using JDK 1.4 (which doesn't contain the XToolkit/XAWT backend) or setting the
environment variable
.BR AWT_TOOLKIT=MToolkit
(to use the older Motif backend instead) or running
.B xprop -root -f _NET_WM_NAME 32a -set _NET_WM_NAME LG3D
or
.B wmname LG3D
(to pretend that a non-reparenting window manager is running that the
XToolkit/XAWT backend can recognize) or when using OpenJDK setting the environment variable
.BR _JAVA_AWT_WM_NONREPARENTING=1 .
.SH BUGS
Send all bug reports with a patch to hackers@suckless.org.
